﻿J = jQuery.noConflict();
var twitter = new Object();

twitter.parseText = function (text) {
	var regexp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
	text = text.replace(regexp, '<a href="$1" target="_blank">$1</a>');

	var regexp = /\s?(#([A-Z0-9äöü]+))/ig;
	text = text.replace(regexp, ' <a href="http://twitter.com/search?q=%23$2" target="_blank">$1</a>');

	regexp = /([@])([\w]+)/ig;

	return text.replace(regexp, '<a href="http://twitter.com/$2" target="_blank">$1$2</a>');
}

twitter.parseSource = function (source) {
	regexp = /rel="nofollow"/ig;
	source = source.replace(regexp, '');

	return source;
}

String.prototype.delNofollow = function () {
	return this.replace(/ ?rel="nofollow"/ig, '');
}

twitter.calcTime = function (tstr) {
	var now = new Date();
	var d = tstr.substring(8, 10);
	var m = tstr.substring(4, 7);
	var y = tstr.substring(26, 30);
	var time = tstr.substring(10, 19);
	var date = d + ' ' + m + ' ' + y + ' ' + time + ' +0000';
	var ts = parseInt(Date.parse(date)) / 1000;
	var diff = Math.round(now.getTime() / 1000 - ts);

	if (diff < 60) {
		var str = diff + ' Sekunde' + ((diff > 1) ? 'n' : '');
	} else if (diff < 3600) {
		var str = Math.round(diff / 60);
		str += ' Minute' + ((str > 1) ? 'n' : '');
	} else if (diff < 86400) {
		var str = Math.round(diff / 3600);
		str += ' Stunde' + ((str > 1) ? 'n' : '');
	} else {
		var str = Math.round(diff / 86400);
		str += ' Tag' + ((str > 1) ? 'en' : '');
	}

	return str;
}
twitter.load = function (name, tweetcount) {
	J.getJSON('http://twitter.com/status/user_timeline/' + name + '.json?count=' + tweetcount + '&callback=?', function(data) {
		var twitterbox = document.getElementById('tweetview_tweetlist');
		twitterbox.innerHTML = '';

		J.each(data, function(i, tweet) {
			if (tweet.created_at != undefined) {
				text = twitter.parseText(tweet.text);
				//source = twitter.parseSource(tweet.source);
				source = tweet.source.delNofollow();

				var lItem = document.createElement('li');

				lItem.setAttribute('class', 'tweet');

				twitterbox.appendChild(lItem);
				//twitterbox.lastChild.innerHTML = text + '<br \/>' + 'Vor <a href="http://twitter.com/' + name + '/status/' + tweet.id + '" target="_blank">' + twitter.calcTime(tweet.created_at) + '</a> via ' + tweet.source;
				twitterbox.lastChild.innerHTML = text + '<br \/>' + 'Vor <a href="http://twitter.com/' + name + '/status/' + tweet.id + '" target="_blank">' + twitter.calcTime(tweet.created_at) + '</a> via ' + source;
			}
		});
	});
}